; 
    include \masm32\include\masm32rt.inc
; 
    .data

      ; Specify fixed values in case somebody is using 640 x 480
      ; resolution, then these become the default values

      StaticWidth dd  384   ; Minimum static width of screen
      MinHeight   dd  384   ; Default minimum height
      MaxHeight   dd  480   ; Default maximum height

      hInst       dd          0
      hWnd        dd          0
      wcx         WNDCLASSEX  <>
      msg         MSG         <>

      mmi         MINMAXINFO  <>

      className   db "test_window_class", 0

    .code
; 

WndProc proc hwnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL rc:RECT
    LOCAL szTitle[30]:BYTE

    push edi
    push esi

    SWITCH uMsg

      CASE WM_CREATE

        ; Calculate screen extents applicable to this applications.
        ; Height = 75%, Min 37.5% or 384 which ever is greater Max 100%
        ; Width = 37.5% or minimum of 480

        push  SM_CXSCREEN           ; Get width of current screen
        call  GetSystemMetrics
        cmp ax, 640                 ; Is anybody using this anymore!
        jbe @F                      ; Nothing to do
        shr eax, 1                  ; Width = Width / 2
        mov ecx, eax
        shr ecx, 2                  ; Skew = 1/2 Width / 4
        sub eax, ecx                ; EAX = 37.5% of current width
        mov StaticWidth, eax

        push  SM_CYSCREEN           ; Get height of current screen
        call  GetSystemMetrics
        mov   MaxHeight, eax
        shr   eax, 1
        mov   ecx, eax              ; Set above
        shr   ecx, 2
        sub   eax, ecx
        mov   MinHeight, eax        ; Values set for WM_GETMINMAXINFO

      @@:

      CASE WM_GETMINMAXINFO

        mov edi, lParam             ; Pointer to MINMAXINFO
        add edi, 24                 ; Bump to ptMinTrackSize
        mov esi, offset StaticWidth
        lodsd                       ; Get static width of window
        stosd                       ; Store @ ptMinTrackSize.x
        mov [edi + 4], eax          ; Store @ ptMaxTrackSize.x
        lodsd                       ; Get Minimum height
        stosd                       ; Store @ ptMinTrackSize

      CASE WM_SIZE

        invoke RtlZeroMemory, ADDR szTitle, 30
        invoke GetWindowRect, hwnd, ADDR rc
        mov edx, rc.right
        sub edx, rc.left
        mov eax, add$(ADDR szTitle,ustr$(edx))
        mov eax, add$(ADDR szTitle,chr$("x"))
        mov edx, rc.bottom
        sub edx, rc.top
        mov eax, add$(ADDR szTitle,ustr$(edx))
        invoke SetWindowText, hwnd, ADDR szTitle

      CASE WM_CLOSE

        invoke DestroyWindow, hwnd

      CASE WM_DESTROY

        invoke PostQuitMessage,NULL

      DEFAULT

        invoke DefWindowProc, hwnd, uMsg, wParam, lParam

        pop esi
        pop edi

        ret

    ENDSW

    pop esi
    pop edi

    xor eax, eax
    ret

WndProc endp

; 
start:
; 

    invoke GetModuleHandle, NULL
    mov hInst, eax

    mov wcx.cbSize,        sizeof WNDCLASSEX
    mov wcx.style,         CS_HREDRAW or CS_VREDRAW \
                            or CS_BYTEALIGNWINDOW
    mov wcx.lpfnWndProc,   OFFSET WndProc
    mov wcx.cbClsExtra,    NULL
    mov wcx.cbWndExtra,    NULL
    m2m wcx.hInstance,     hInst
    invoke GetStockObject, WHITE_BRUSH
    mov wcx.hbrBackground, eax
    mov wcx.lpszMenuName,  NULL
    mov wcx.lpszClassName, OFFSET className
    invoke LoadIcon, NULL, IDI_APPLICATION
    mov wcx.hIcon,         eax
    invoke LoadCursor, NULL, IDC_ARROW
    mov wcx.hCursor,       eax
    mov wcx.hIconSm,       0

    invoke RegisterClassEx,ADDR wcx

    invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,
                          ADDR className,
                          chr$("Test"),
                          WS_OVERLAPPEDWINDOW,
                          0,0,200,150,
                          NULL,NULL,
                          hInst,NULL
    mov hWnd, eax

    invoke ShowWindow, hWnd, SW_SHOWNORMAL
    invoke UpdateWindow, hWnd

; 

  msgLoop:

    invoke GetMessage, ADDR msg, NULL, 0, 0
    .IF (eax != 0)
        invoke TranslateMessage, ADDR msg
        invoke DispatchMessage, ADDR msg
        jmp msgLoop
    .ENDIF
    exit msg.wParam

; 

end start